ACTOR MinigunLoopCounter : Inventory
{
	Inventory.MaxAmount 210
}

Actor MinigunSpawner : RandomSpawner replaces ChaingunSpawnerReplacer
{
	DropItem "MiniGun", 255, 5
	DropItem "MinigunReal", 255, 1
}

ACTOR MinigunRealClip : Ammo
{
	Inventory.Amount 0
	Inventory.MaxAmount 600
	Ammo.BackpackAmount 0
	Ammo.BackpackMaxAmount 1200
	Inventory.Icon "CLIPA0"
	States
	{
		Spawn:
		TNT1 A -1
		Stop
	}
}

ACTOR MinigunReal : BrutalWeapon
{
	Weapon.SelectionOrder 700
	Weapon.AmmoType1 "MinigunRealClip"
	Weapon.AmmoType2 "Clip2"
	Weapon.AmmoGive1 300
	Weapon.AmmoGive2 300
	Weapon.AmmoUse1 0
	+WEAPON.NOAUTOAIM
	+WEAPON.NOAUTOFIRE
	+FORCEXYBILLBOARD
	Inventory.PickupSound "CBOXPKUP"
	Inventory.PickupMessage "You got the Minigun!"
	Obituary "%o was mowed down by %k's Minigun."
	AttackSound "none"
	Scale 0.9
	States
	{
	Spawn:
		MGIC A 1
		MGIC A -1
		Stop
		
	Ready: 
	Ready3:
		TNT1 A 0 A_JumpIfInventory("Kicking",1,"DoKick")
		
		TNT1 A 0 A_JumpIfInventory("Salute1", 1, "Salute")
		TNT1 A 0 A_JumpIfInventory("Salute2", 1, "Salute")
		TNT1 A 0 A_JumpIfInventory("Taunting",1,"Taunt")
		CHMF A 1 A_WeaponReady
		TNT1 A 0 A_JumpIfInventory("TossGrenade",1,"TossGrenade")
			
		TNT1 A 0 A_JumpIfInventory("Reloading", 1, "Reload")
		TNT1 A 0 A_JumpIfInventory("Unloading", 1, "Reload")
		TNT1 A 0 A_JumpIfInventory("Spin",1,"Ready2")
		Goto Ready
	
	IdleNoAmmo:
		CHMF A 1 A_WeaponReady
		TNT1 A 0 A_TakeInventory ("Spin",1)
		TNT1 A 0 A_JumpIfInventory("MinigunRealClip",1,"Ready")
		TNT1 A 0 A_JumpIfInventory("Kicking",1,"DoKick")
		TNT1 A 0 A_JumpIfInventory("Taunting",1,"Taunt")
		TNT1 A 0 A_JumpIfInventory("TossGrenade",1,"TossGrenade")
		TNT1 A 0 A_JumpIfInventory("Reloading", 1, "Reload")
		TNT1 A 0 A_JumpIfInventory("Unloading", 1, "Reload")
		Loop

	Ready2:
		TNT1 A 0 A_JumpIfInventory("Kicking",1,"DoKick")
		TNT1 A 0 A_JumpIfInventory("Taunting",1,"Taunt")
		TNT1 A 0 A_JumpIfInventory("TossGrenade",1,"TossGrenade")
		TNT1 A 0 A_JumpIfInventory("Reloading", 1, "Reload")
		TNT1 A 0 A_JumpIfInventory("Unloading", 1, "Reload")
		CHMF ABCD 1 A_WeaponReady 
		TNT1 A 0 A_AlertMonsters
		TNT1 A 0 A_PlaySound("CHAINSPI", 5)
		Loop


	Deselect:
		TNT1 A 0 A_TakeInventory("Spin",1)
		TNT1 A 0 A_TakeInventory("TossGrenade", 1)
		TNT1 A 0 A_Takeinventory("HeavyAutomaticWeapon",1)
		TNT1 A 0 A_TakeInventory("RandomHeadExploder", 1)
		TNT1 A 0 A_TakeInventory("MinigunLoopCounter", 210)
		TNT1 A 0 A_TakeInventory("Unloading", 1)
		TNT1 A 0 A_TakeInventory("Reloading", 1)
		TNT1 A 0 A_StopSound(1) // stops full auto fire sound
		TNT1 A 0 SetPlayerProperty(0,0,0)
		CHMK DCBA 1
		TNT1 AAAAAAAAAAAAAAAAAA 0 A_Lower
		TNT1 A 1 A_Lower
		Wait

	Select:
		TNT1 A 0
		TNT1 A 0 A_Giveinventory("GoSpecial",1)
		TNT1 A 0 A_Giveinventory("HeavyAutomaticWeapon",1)
		TNT1 A 0 A_Takeinventory("FistsSelected",1)
		TNT1 A 0 A_Takeinventory("SawSelected",1)
		TNT1 A 0 A_Takeinventory("ShotgunSelected",1)
		TNT1 A 0 A_Takeinventory("SSGSelected",1)
		TNT1 A 0 A_Giveinventory("MinigunSelected",1)
		TNT1 A 0 A_Takeinventory("PlasmaGunSelected",1)
		TNT1 A 0 A_Takeinventory("RocketLauncherSelected",1)
		TNT1 A 0 A_Takeinventory("GrenadeLauncherSelected",1)
		TNT1 A 0 A_Takeinventory("BFGSelected",1)
		TNT1 A 0 A_Takeinventory("BFG10kSelected",1)
		TNT1 A 0 A_Takeinventory("RailGunSelected",1)
		TNT1 A 0 A_Takeinventory("Reloading",1)
		TNT1 A 0 A_Takeinventory("Unloading",1)
		TNT1 A 0 A_Takeinventory("SubMachineGunSelected",1)
		TNT1 A 0 A_Takeinventory("RevenantLauncherSelected",1)
		TNT1 A 0 A_Takeinventory("LostSoulSelected",1)
		TNT1 A 0 A_Takeinventory("FlameCannonSelected",1)
		TNT1 A 0 A_Takeinventory("HasBarrel",1)
		TNT1 A 0 A_TakeInventory("TossGrenade", 1)
		TNT1 A 0 A_TakeInventory("Unloading", 1)
		TNT1 A 0 A_TakeInventory("Reloading", 1)
		TNT1 A 0 A_TakeInventory("MinigunLoopCounter", 210)
		TNT1 A 0 A_GiveInventory("RandomHeadExploder", 1)
		TNT1 A 0 A_JumpIfInventory("IsPlayingAsPurist", 1, "PuristGun")
		TNT1 A 0 A_PlaySound("CHGNPKUP")
		CHMF AAAAAA 1 A_Raise
		TNT1 AAAAAA 0 A_Raise
	
	SelectAnimation:
		TNT1 A 0
		// TNT1 A 0 A_GunFlash
		CHMK ABCD 1 A_JumpIfInventory("GoFatality", 1, "Steady")
		Goto Ready

	NoAmmo:
		TNT1 A 0 A_PlaySound("weapons/empty", 1)
		CHMF A 10
		TNT1 A 0 A_TakeInventory("MinigunLoopCounter", 210)
		Goto Reload+4

	Reload:
		TNT1 A 0 A_JumpIfInventory("Reloading", 1, 4)
		TNT1 A 0 A_JumpIfInventory("Clip2", 0, 2)
		TNT1 A 0 A_JumpIfInventory("MinigunRealClip", 1, 5)
		TNT1 A 0 A_TakeInventory("Unloading", 1)
		Goto Ready
		TNT1 A 0 A_JumpIfInventory("MinigunRealClip", 0, 2)
		TNT1 A 0 A_JumpIfInventory("Clip2", 1, 2)
		TNT1 A 0 A_TakeInventory("Reloading", 1)
		Goto Ready
		CHMR A 2
		CHMR B 2
		CHMR C 2
		CHMR D 2
		CHMR D 2 Offset(-2, 32)
		CHMR D 2 Offset(-4, 34)
		CHMR D 2 Offset(-6, 36)
		CHMR D 2 Offset(-8, 38)
		CHMR D 2 Offset(-10, 40)
		CHMR D 2 Offset(-12, 42)
		TNT1 A 0 A_PlaySound("weapons/minigun-real/open", 1)
		CHMR D 4 Offset(-14, 44)
		TNT1 A 0 A_PlaySound("weapons/minigun-real/load", 1)
		CHMR D 4 Offset(-12, 46)
		CHMR D 4 Offset(-11, 43)
		CHMR D 4 Offset(-13, 45)
		CHMR D 4 Offset(-12, 43)
		CHMR D 4 Offset(-12, 46)
		CHMR D 4 Offset(-11, 43)
		CHMR D 4 Offset(-13, 45)
		CHMR D 4 Offset(-12, 43)
		CHMR D 4 Offset(-12, 46)
		CHMR D 4 Offset(-11, 43)
		CHMR D 4 Offset(-13, 45)
		CHMR D 4 Offset(-12, 43)
		CHMR D 4 Offset(-12, 46)
		CHMR D 4 Offset(-11, 43)
		CHMR D 4 Offset(-13, 45)
		CHMR D 4 Offset(-12, 43)
		CHMR D 4 Offset(-12, 43)
		TNT1 A 0 A_PlaySound("weapons/minigun-real/close", 1)
		TNT1 A 0 A_JumpIfInventory("Unloading", 1, "RemoveBullets")
		Goto InsertBullets
	InsertBullets:
		TNT1 A 0 A_JumpIfInventory("MinigunRealClip", 0, "ReloadFinish")
		TNT1 A 0 A_JumpIfInventory("Clip2", 1, 1)
		Goto ReloadFinish

		TNT1 A 0 A_GiveInventory("MinigunRealClip", 1)
		TNT1 A 0 A_TakeInventory("Clip2", 1)
		Goto InsertBullets
	RemoveBullets:
		TNT1 A 0 A_JumpIfInventory("Clip2", 0, "ReloadFinish")
		TNT1 A 0 A_JumpIfInventory("MinigunRealClip", 1, 1)
		Goto ReloadFinish

		TNT1 A 0 A_GiveInventory("Clip2", 1)
		TNT1 A 0 A_TakeInventory("MinigunRealClip", 1)
		Goto RemoveBullets
	ReloadFinish:
		CHMR D 2 Offset(-12, 42)
		CHMR D 2 Offset(-10, 40)
		CHMR D 2 Offset(-8, 38)
		CHMR D 2 Offset(-6, 36)
		CHMR D 2 Offset(-4, 34)
		CHMR D 2 Offset(-2, 32)
		CHMR C 2
		CHMR B 2
		CHMR A 2
		TNT1 A 0 A_TakeInventory("Reloading", 1)
		TNT1 A 0 A_TakeInventory("Unloading", 1)
		Goto Ready

	Fire:
		TNT1 A 0
		TNT1 A 0 A_JumpIfInventory("Spin",1,"Hold")
		TNT1 A 0 A_PlaySound("CHAINSTA", 5)
		TNT1 A 0 BRIGHT A_FireCustomMissile("Alerter", 0, 0, 0, 0)
		CHMF BC 1
		CHMF D 1
		CHMF AB 1
		TNT1 A 0 A_StopSound(5)
		//TNT1 A 0 A_PlaySound("CHAINSPI", 5)
		TNT1 A 0
	Hold:
		TNT1 A 0 A_JumpIfInventory("Salute1", 1, "Salute")
		TNT1 A 0 A_JumpIfInventory("Salute2", 1, "Salute")
		TNT1 A 0 A_JumpIfInventory("MinigunRealClip", 1, 1)
		Goto NoAmmo
		
		TNT1 A 0 A_JumpIfInventory("MinigunLoopCounter", 1, 3)
		TNT1 A 0 A_GiveInventory("MinigunLoopCounter", 210)
		TNT1 A 0 A_PlaySound("weapons/minigun-real/fire", 1)
		// TNT1 A 0 A_PlaySound("FARMGN", 5)
		TNT1 A 0 A_ZoomFactor(0.98)

		TNT1 A 0 A_Firecustommissile("50CaseSpawn",0,0,-12,-18)
		TNT1 A 0 A_SpawnItemEx("PlayerMuzzle2",30,5,27)
		TNT1 A 0 A_ZoomFactor(1.0)
		TNT1 A 0 A_SetAngle(frandom(-0.8, 0.8) + angle)
		TNT1 A 0 A_SetPitch(-0.4 + pitch)
		TNT1 A 0 A_FireCustomMissile("DecorativeTracer", frandom(-1.0, 1.0), 0, 0, -12, 0, frandom(-1.0, 1.0))
		CHMG A 1 BRIGHT A_FireBullets(2.0, 2.0, -1, 16, "MachineGunBulletPuff", FBF_NORANDOM)
		TNT1 A 0 A_TakeInventory("MinigunRealClip", 1)

		TNT1 A 0 A_JumpIfInventory("MinigunRealClip", 1, 2)
		TNT1 A 0 A_PlaySound("weapons/minigun-real/post", 1)
		Goto NoAmmo+1
		TNT1 A 0 A_FireCustomMissile("DecorativeTracer", frandom(-1.0, 1.0), 0, 0, -12, 0, frandom(-1.0, 1.0))
		TNT1 A 0 A_FireBullets(2.0, 2.0, -1, 16, "MachineGunBulletPuff", FBF_NORANDOM)
		TNT1 A 0 A_TakeInventory("MinigunRealClip", 1)
		TNT1 A 0 A_TakeInventory("MinigunLoopCounter", 1)
		// CHMG B 1

		// TNT1 A 0 A_PlaySound("weapons/minigun-real", 2)
		// TNT1 A 0 A_PlaySound("FARMGN", 5)
		TNT1 A 0 A_ZoomFactor(0.98)

		TNT1 A 0 A_JumpIfInventory("MinigunRealClip", 1, 2)
		TNT1 A 0 A_PlaySound("weapons/minigun-real/post", 1)
		Goto NoAmmo+1
		TNT1 A 0 A_Firecustommissile("50CaseSpawn",0,0,-12,-18)
		TNT1 A 0 A_SpawnItemEx("PlayerMuzzle3",30,5,27)
		TNT1 A 0 A_FireCustomMissile("DecorativeTracer", frandom(-1.0, 1.0), 0, 0, -12, 0, frandom(-1.0, 1.0))
		TNT1 A 0 A_Jump(196, 3)
		CHMG G 1 BRIGHT A_FireBullets(2.0, 2.0, -1, 16, "MachineGunBulletPuff", FBF_NORANDOM)
		TNT1 A 0 A_Jump(256, 2)
		CHMG J 1 BRIGHT A_FireBullets(2.0, 2.0, -1, 16, "MachineGunBulletPuff", FBF_NORANDOM)
		TNT1 A 0 A_TakeInventory("MinigunRealClip", 1)
		TNT1 A 0 A_SetAngle(frandom(-0.8, 0.8) + angle)
		TNT1 A 0 A_SetPitch(-0.4 + pitch)
		TNT1 A 0 A_ZoomFactor(1.0)

		TNT1 A 0 A_JumpIfInventory("MinigunRealClip", 1, 2)
		TNT1 A 0 A_PlaySound("weapons/minigun-real/post", 1)
		Goto NoAmmo+1
		TNT1 A 0 A_FireBullets(2.0, 2.0, -1, 16, "MachineGunBulletPuff", FBF_NORANDOM)
		TNT1 A 0 A_TakeInventory("MinigunRealClip", 1)
		TNT1 A 0 A_TakeInventory("MinigunLoopCounter", 1)

		// CHMG D 1

		MNGG B 0 A_ReFire
		TNT1 A 0 A_PlaySound("MINIGEN", 5)
		TNT1 A 0 A_PlaySound("weapons/minigun-real/post", 1)
		TNT1 A 0 A_TakeInventory("MinigunLoopCounter", 210)
		TNT1 A 0 A_JumpIfInventory("Spin",1,"Ready2")
		
		TNT1 A 0 A_JumpIfInventory("Kicking",1,"DoKick")
		TNT1 A 0 A_JumpIfInventory("Salute1", 1, "Salute")
		TNT1 A 0 A_JumpIfInventory("Salute2", 1, "Salute")
		TNT1 A 0 A_PlaySound("CHAINSTO", 5)
		CHMF A 1 A_WeaponReady
		
		CHMF B 1 A_WeaponReady
		TNT1 A 0 A_Refire
		
		CHMF C 1 A_WeaponReady
		TNT1 A 0 A_FireCustomMissile("SmokeSpawner11",0,0,0,0)
		CHMG D 1 A_WeaponReady

		TNT1 A 0 A_JumpIfInventory("Kicking",1,"DoKick")
		
		TNT1 A 0 A_JumpIfInventory("Salute1", 1, "Salute")
		TNT1 A 0 A_JumpIfInventory("Salute2", 1, "Salute")
		CHMF A 1 A_WeaponReady
		TNT1 A 0 A_JumpIfInventory("TossGrenade",1,"TossGrenade")
		TNT1 A 0 A_JumpIfInventory("Kicking",1,"DoKick")
		
		CHMF B 1 A_WeaponReady
		TNT1 A 0 A_FireCustomMissile("SmokeSpawner11",0,0,0,0)
		CHMF C 2 A_WeaponReady
		
		CHMF D 2 A_WeaponReady
		TNT1 A 0 A_FireCustomMissile("SmokeSpawner11",0,0,0,0)
		TNT1 A 0 A_JumpIfInventory("Spin",1,"Ready2") 
		TNT1 A 0 A_TakeInventory("Spin", 1)
		TNT1 A 0 A_JumpIfInventory("Salute1", 1, "Salute")
		TNT1 A 0 A_JumpIfInventory("Salute2", 1, "Salute")
		TNT1 A 0 A_JumpIfInventory("TossGrenade",1,"TossGrenade")
		TNT1 A 0 A_JumpIfInventory("Kicking",1,"DoKick")
		
		CHMF A 2 A_WeaponReady
		
		CHMF B 2 A_WeaponReady
		TNT1 A 0 A_FireCustomMissile("SmokeSpawner11",0,0,0,0)
		CHMF C 2 A_WeaponReady
		
		CHMF D 2 A_WeaponReady
		TNT1 A 0 A_FireCustomMissile("SmokeSpawner11",0,0,0,0)
		TNT1 A 0 A_JumpIfInventory("TossGrenade",1,"TossGrenade")
		TNT1 A 0 A_JumpIfInventory("Kicking",1,"DoKick")
		CHMF ABCD 2 A_WeaponReady
		TNT1 A 0 A_JumpIfInventory("TossGrenade",1,"TossGrenade")
		TNT1 A 0 A_JumpIfInventory("Kicking",1,"DoKick")
		CHMF ABCD 3 A_WeaponReady
		
		goto Ready



	AltFire:
		TNT1 A 0 A_JumpIfInventory("Spin",1,"StopAlt")
		TNT1 A 0 A_GiveInventory ("Spin",1)
		TNT1 A 0 A_PlaySound("CHAINSTA", 5)
		TNT1 A 0 A_JumpIfInventory("MinigunRealClip", 1, 1)
		Goto IdleNoAmmo
		CHMF ABCD 2
		TNT1 A 0
		Goto Ready2

	StopAlt:
		TNT1 A 0
		TNT1 A 0 A_TakeInventory ("Spin",1)
		TNT1 A 0 A_PlaySound("CHAINSTO", 6)
		TNT1 A 0 A_StopSound(5)
		TNT1 A 0 A_StopSound(1)
		CHMF ABCD 1
		CHMF ABCDABCD 2 A_WeaponReady
		CHMF ABCD 3 A_WeaponReady
		TNT1 A 0
		Goto Ready
		}
}